package io.zipcoder;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

public class MonkeyTypewriter {
    public static void main(String[] args) {

        String introduction = "It was the best of times,\n" +
                "it was the blurst of times,\n" +
                "it was the age of wisdom,\n" +
                "it was the age of foolishness,\n" +
                "it was the epoch of belief,\n" +
                "it was the epoch of incredulity,\n" +
                "it was the season of Light,\n" +
                "it was the season of Darkness,\n" +
                "it was the spring of hope,\n" +
                "it was the winter of despair,\n" +
                "we had everything before us,\n" +
                "we had nothing before us,\n" +
                "we were all going direct to Heaven,\n" +
                "we were all going direct the other way--\n" +
                "in short, the period was so far like the present period, that some of\n" +
                "its noisiest authorities insisted on its being received, for good or for\n" +
                "evil, in the superlative degree of comparison only.";

        UnsafeCopier unsafeMonkey = new UnsafeCopier(introduction);
        Thread thread[] = new Thread[5];
        for(int i = 0; i < 5; i++) {
            thread[i] = new Thread(unsafeMonkey);
            thread[i].start();
        }

        SafeCopier safeMonkey = new SafeCopier(introduction);
        Thread thread1[] = new Thread[5];
        for(int i = 0; i < 5; i++) {
            thread1[i] = new Thread(safeMonkey);
            thread1[i].start();
        }

        try {
            Thread.sleep(1000);
        } catch(InterruptedException e) {
            System.out.println("MAIN INTERRUPTED");
        }

        System.out.println("UnsafeMonkey: " + unsafeMonkey.copied);
        System.out.println("SafeMonkey: " + safeMonkey.copied);
    }
}