package io.zipcoder;

import java.util.concurrent.locks.ReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;

/**
 * Make this extend the Copier like `UnsafeCopier`, except use locks to make sure that the actual intro gets printed
 * correctly every time.  Make the run method thread safe.
 */
public class SafeCopier extends Copier{

    public SafeCopier(String toCopy) {
        super(toCopy);
    }

    public void run() {
        ReadWriteLock rwl = new ReentrantReadWriteLock();
        rwl.writeLock().lock();
        rwl.readLock().lock();
        try {
            while(stringIterator.hasNext()) copied += stringIterator.next() + " ";
        } finally {
            rwl.writeLock().unlock();
            rwl.readLock().unlock();
        }
    }
}
